#include <iostream>

class A {
public:
	virtual void f() = 0;
	virtual void g() = 0;
};

class B : public A {
	int x = 1;
public:
	virtual void f() {
		std::cout << "B::f called, x == " << x << std::endl;
	}
	virtual void g() {
		std::cout << "B::g called, x == " << x << std::endl;
	}
};

class C : public A {
	int y = 2;
public:
	virtual void f() {
		std::cout << "C::f called, y == " << y << std::endl;
	}	
	virtual void g() {
		std::cout << "C::g called, y == " << y << std::endl;
	}
};

void callMethod(void (A::*ptr)()) {
	A *a = new B();
	(a->*ptr)();

	a = new C();
	(a->*ptr)();
}

int main() {
	std::cout << "main: testing with f:" << std::endl;
	callMethod(&A::f);

	std::cout << "main: testing with g:" << std::endl;
	callMethod(&A::g);
}